diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index f145f1694..6edabf547 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -3,7 +3,6 @@ package net.minecraft.core.entity.player;
 import com.mojang.nbt.tags.*;
 import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.block.entity.*;
-import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.*;
 import net.minecraft.core.entity.animal.MobPig;
@@ -55,6 +54,9 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.BiomeTags;
+import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePos;
@@ -92,6 +94,7 @@ public abstract class Player
     public @NotNull Gamemode gamemode = Gamemodes.SURVIVAL;
     //    public byte userType;
     public int score;
+    private int acidStandingTicks;
     public List<String> messageHistory = new ArrayList<>();
     public float cameraVelocityOld;
     public float cameraVelocity;
@@ -114,6 +117,9 @@ public abstract class Player
     private @Nullable TilePos playerSpawnPoint;
     private @Nullable TilePos lastDeathPoint;
     private @Nullable TilePos startMinecartRidingPoint;
+    public record FluidPlacement(int dimensionId, int x, int y, int z, long tick) {}
+    public @Nullable FluidPlacement lastAcidPlacement;
+    public @Nullable FluidPlacement lastWaterPlacement;
     public int timeUntilPortal;
     protected boolean inPortal;
     public int portalID;
@@ -281,7 +287,7 @@ public abstract class Player
 
         final boolean wSneak = wantSneak();
 
-        if (wSneak || this.noPhysics) {
+        if (wSneak || hasNoPhysics()) {
             this.sneaking = wSneak;
         } else {
             if (boundsClear(getBoundsForState(MOTION_STATE_DEFAULT))) {
@@ -313,6 +319,23 @@ public abstract class Player
             }
         }
         super.tick();
+        if (!this.world.isClientSide
+            && this.world.getDimension() == Dimension.NETHER
+            && this.tickCount % 100 == 0) {
+            final Biome biome = this.world.getBlockBiome(new TilePos(this));
+            if (biome.hasTag(BiomeTags.HAS_SULFUR_POOLS)) {
+                addStat(Achievements.DISCOVER_SULFURPOOLS, 1);
+            }
+            if (biome == Biomes.NETHER_VOLCANIC_ISLANDS) {
+                addStat(Achievements.DISCOVER_VOLCANICISLANDS, 1);
+            }
+            if (biome.hasTag(BiomeTags.HAS_CRYSTAL_VEINS)) {
+                addStat(Achievements.DISCOVER_CRYSTALFOREST, 1);
+            }
+            if (biome.hasTag(BiomeTags.HAS_SURFACE_ASH)) {
+                addStat(Achievements.DISCOVER_OLDWORLD, 1);
+            }
+        }
         if (this.heldObject != null) {
             this.heldObject.heldTick(this.world, this);
         }
@@ -454,9 +477,20 @@ public abstract class Player
             this.acidExitDelayLeft = 0;
             this.acidPostExitPeak = 0;
             this.acidPostExitDrainTicksLeft = 0;
+            this.acidStandingTicks = 0;
             return;
         }
         super.acidTick();
+        if (!this.world.isClientSide) {
+            if (isInAcid()) {
+                this.acidStandingTicks++;
+                if (this.acidStandingTicks > 200) {
+                    triggerAchievement(Achievements.ACID_BATH);
+                }
+            } else {
+                this.acidStandingTicks = 0;
+            }
+        }
     }
 
     public boolean shouldShowAcidVisualEffects() {
@@ -794,7 +828,7 @@ public abstract class Player
 
     @Override
     public void push(@NotNull Entity entity) {
-        if (this.noPhysics || !getGamemode().canInteract()) return;
+        if (hasNoPhysics() || !getGamemode().canInteract()) return;
         super.push(entity);
     }
 
@@ -905,7 +939,7 @@ public abstract class Player
         } else {
             this.setGamemodeOnLogin(Gamemodes.SURVIVAL);
         }
-        this.noPhysics = tag.getBoolean("Noclip") && this.gamemode.hasPlayerFlight();
+        setNoPhysics(tag.getBoolean("Noclip") && this.gamemode.hasPlayerFlight());
         this.sneaking = tag.getBoolean("Sneaking");
         if (this.sleeping) {
             this.bedTilePos = new TilePos(this);
@@ -933,7 +967,7 @@ public abstract class Player
         tag.putBoolean("Sleeping", this.sleeping);
         tag.putShort("SleepTimer", (short) this.sleepTimer);
         tag.putString("Gamemode", this.gamemode.getId());
-        tag.putBoolean("Noclip", this.noPhysics && this.gamemode.hasPlayerFlight());
+        tag.putBoolean("Noclip", hasNoPhysics() && this.gamemode.hasPlayerFlight());
         tag.putBoolean("Sneaking", this.sneaking);
         if (this.playerSpawnPoint != null) {
             tag.putInt("SpawnX", this.playerSpawnPoint.x);
@@ -1472,6 +1506,9 @@ public abstract class Player
         addStat(statbase, 1);
     }
 
+    public void revokeAchievement(Stat statbase) {
+    }
+
     public void addStat(@Nullable Stat stat, int i) {
     }
 
@@ -1640,7 +1677,7 @@ public abstract class Player
         }
         this.inventoryMenu = newContainer;
         if (!gamemode.hasPlayerFlight()) {
-            this.noPhysics = false;
+            setNoPhysics(false);
         }
 
         this.fireImmune = gamemode.hasFireImmunity();
@@ -1652,8 +1689,8 @@ public abstract class Player
     }
 
     public void setNoclip(final boolean noclip) {
-        this.noPhysics = noclip;
-        if (this.noPhysics) {
+        setNoPhysics(noclip);
+        if (hasNoPhysics()) {
             this.yd += 0.079f;
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowGolden.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowGolden.java
index 4ef9a4701..a0ca22147 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowGolden.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowGolden.java
@@ -12,21 +12,21 @@ public class ProjectileArrowGolden extends ProjectileArrow
     public ProjectileArrowGolden(World world)
     {
         super(world, TYPE_GOLDEN);
-        this.noPhysics = true;
+        setNoPhysics(true);
         stack = new ItemStack(Items.AMMO_ARROW_GOLD);
     }
 
     public ProjectileArrowGolden(World world, double x, double y, double z)
     {
         super(world, x, y, z, TYPE_GOLDEN);
-        this.noPhysics = true;
+        setNoPhysics(true);
         stack = new ItemStack(Items.AMMO_ARROW_GOLD);
     }
 
     public ProjectileArrowGolden(World world, Mob owner, boolean doesArrowBelongToPlayer)
     {
         super(world, owner, doesArrowBelongToPlayer, TYPE_GOLDEN);
-        this.noPhysics = true;
+        setNoPhysics(true);
         stack = new ItemStack(Items.AMMO_ARROW_GOLD);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 19fb9d14e..198181725 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item;
 
 import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.Blocks;
@@ -30,6 +31,8 @@ import org.joml.primitives.AABBd;
 import java.util.*;
 import java.util.function.BiConsumer;
 
+// TODO: the abstractions here might be too overcomplicatted
+// ik reworking things might be a pain for modders but this really is not designed in a good way
 public abstract class ItemBucket extends ItemFood implements IItemContainer {
 
     /**
@@ -244,14 +247,6 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
         // return STATE_EMPTY.equals(currentStateId) || getCharges(selfStack) < this.maxCharges;
     }
 
-    @Override
-    public boolean interactsWithEntity(@NotNull ItemStack selfStack, @NotNull Entity entity) {
-        if (!super.interactsWithEntity(selfStack, entity)) return false;
-        final NamespaceID currentStateId = getState(selfStack);
-        final BucketState currentState = getBucketState(currentStateId);
-        return currentState.canPlace() || !currentState.isEdible();
-    }
-
     @Override
     public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
         final NamespaceID currentStateId = getState(selfStack);
@@ -303,19 +298,11 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
 
     @Override
     public boolean useOnEntity(@NotNull ItemStack selfStack, @NotNull Player player, @NotNull Mob mob) {
-        final NamespaceID currentStateId = getState(selfStack);
-        final BucketState currentState = getBucketState(currentStateId);
-
-        if (currentState.isEdible() && !currentState.canPlace()) return false;
-
-        final int oldSize = selfStack.stackSize;
-        var newStack = handleEntityClick(selfStack, mob.world, player, mob);
-        if (newStack.stackSize <= 0) newStack = null;
-
-        final boolean isDifferent = oldSize != newStack.stackSize || newStack != selfStack;
-        if (isDifferent) player.inventory.setItem(player.inventory.getCurrentSlot(), newStack);
+        if (mob instanceof MobCow) {
+            return useBucket(selfStack, player, player.world, STATE_MILK);
+        }
 
-        return isDifferent;
+        return false;
     }
 
     // @Override
@@ -392,6 +379,9 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
         if (STATE_EMPTY.equals(currentState)) {
             setState(itemStack, targetState);
             setCharges(itemStack, 1);
+            if (STATE_ACID.equals(targetState) && !world.isClientSide) {
+                player.addStat(Achievements.COLLECT_ACID, 1);
+            }
         } else {
             setCharges(itemStack, getCharges(itemStack) + 1);
         }
@@ -422,6 +412,16 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
         final Block<?> replacedBlock = world.getBlockType(tilePos);
         final int replacedData = world.getBlockData(tilePos);
 
+        if (!world.isClientSide) {
+            if (STATE_ACID.equals(stateId)) {
+                player.lastAcidPlacement = new Player.FluidPlacement(
+                    world.getDimension().id, tilePos.x(), tilePos.y(), tilePos.z(), world.getTotalWorldTime());
+            } else if (STATE_WATER.equals(stateId)) {
+                player.lastWaterPlacement = new Player.FluidPlacement(
+                    world.getDimension().id, tilePos.x(), tilePos.y(), tilePos.z(), world.getTotalWorldTime());
+            }
+        }
+
         if (!world.setBlockTypeNotify(tilePos, bucketState.fluidBlock())) return result;
 
         replacedBlock.dropWithCause(world, EnumDropCause.WORLD, tilePos, replacedData, null, null);
@@ -448,9 +448,9 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
         return itemStack;
     }
 
-    protected ItemStack handleEntityClick(@NotNull ItemStack itemStack, @NotNull World world, @NotNull Player player, @NotNull Entity mob) {
-        return handleAirClick(itemStack, world, player);
-    }
+    // protected ItemStack handleEntityClick(@NotNull ItemStack itemStack, @NotNull World world, @NotNull Player player, @NotNull Entity mob) {
+    //     return handleAirClick(itemStack, world, player);
+    // }
 
     protected ItemStack handleEdibleConsumption(@NotNull ItemStack itemStack, @NotNull World world, @NotNull Player player) {
         NamespaceID state = getState(itemStack);
@@ -472,22 +472,23 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
         return itemStack;
     }
 
-    public static void useBucket(ItemStack itemStack, Player player, World world, NamespaceID targetState) {
+    public static boolean useBucket(ItemStack itemStack, Player player, World world, NamespaceID targetState) {
         boolean isStacked = itemStack.stackSize > 1;
         NamespaceID currentState = getState(itemStack);
 
         int limit = (itemStack.getItem() instanceof ItemBucket bucket) ? bucket.maxCharges : 1;
 
-        if (STATE_EMPTY.equals(currentState) || (currentState.equals(targetState) && getCharges(itemStack) < limit)) {
-            if (!isStacked) {
-                if (STATE_EMPTY.equals(currentState)) {
-                    setState(itemStack, targetState);
-                }
-                setCharges(itemStack, getCharges(itemStack) + 1);
-            } else {
-                splitBucket(itemStack, player, targetState, world);
+        final boolean canUse = STATE_EMPTY.equals(currentState) || (currentState.equals(targetState) && getCharges(itemStack) < limit);
+        if (!canUse) return false;
+        if (!isStacked) {
+            if (STATE_EMPTY.equals(currentState)) {
+                setState(itemStack, targetState);
             }
+            setCharges(itemStack, getCharges(itemStack) + 1);
+        } else {
+            splitBucket(itemStack, player, targetState, world);
         }
+        return true;
     }
 
     protected static ItemStack splitBucket(@NotNull ItemStack itemStack, @NotNull Player player, NamespaceID state, @NotNull World world) {
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
index 99c349963..cc2f87441 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
@@ -4,20 +4,20 @@ import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.builder.ArgumentBuilderLiteral;
 import com.mojang.brigadier.builder.ArgumentBuilderRequired;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.achievement.Achievements;
-import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeAchievement;
-import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
-import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
+import java.util.Comparator;
 import java.util.List;
 
 public class CommandAchievement implements CommandManager.CommandRegistry {
@@ -27,70 +27,130 @@ public class CommandAchievement implements CommandManager.CommandRegistry {
         dispatcher.register(((ArgumentBuilderLiteral.<CommandSource>literal("achievement"))
             .requires(CommandSource::hasAdmin)
             .then((ArgumentBuilderLiteral.<CommandSource>literal("grant"))
-                .then(ArgumentBuilderRequired.<CommandSource, EntitySelector>argument("entities", ArgumentTypeEntity.usernames())
-                    .then(ArgumentBuilderRequired.<CommandSource, Achievement>argument("achievement", ArgumentTypeAchievement.achievement())
-                        .executes(c -> {
-                            CommandSource source = c.getSource();
-                            List<? extends Entity> entities = c.getArgument("entities", EntitySelector.class).get(source);
-                            Achievement achievement = c.getArgument("achievement", Achievement.class);
-
-                            if (entities.size() == 1 && ((Player) entities.get(0)).getStat(achievement) != 0) {
-                                throw PLAYER_ALREADY_HAS_ACHIEVEMENT.create();
-                            }
-
-                            List<Achievement> achievements = new ArrayList<>();
-                            achievements.add(achievement);
-
-                            while (achievements.get(achievements.size() - 1).parent != null) {
-                                achievements.add(achievements.get(achievements.size() - 1).parent);
-                            }
-                            for (int i = 0; i < achievements.size(); i++) {
-                                for (Entity entity : entities) {
-                                    ((Player) entity).triggerAchievement(achievements.get(achievements.size() - 1 - i));
-                                }
-                            }
-
-                            sendContextualMessage(source, entities, achievement);
-
-                            return Command.SINGLE_SUCCESS;
-                        }))
-                    .then(ArgumentBuilderLiteral.<CommandSource>literal("*")
-                        .executes(c -> {
-                            CommandSource source = c.getSource();
-                            List<? extends Entity> entities = c.getArgument("entities", EntitySelector.class).get(source);
-
-                            for (Achievement achievement : Achievements.achievementList) {
-                                List<Achievement> achievements = new ArrayList<>();
-                                achievements.add(achievement);
-                                while (achievements.get(achievements.size() - 1).parent != null) {
-                                    achievements.add(achievements.get(achievements.size() - 1).parent);
-                                }
-                                for (int i = 0; i < achievements.size(); i++) {
-                                    for (Entity entity : entities) {
-                                        ((Player) entity).triggerAchievement(achievements.get(achievements.size() - 1 - i));
-                                    }
-                                }
-                            }
-
-                            sendWildcardContextualMessage(source, entities);
-
-                            return Command.SINGLE_SUCCESS;
-                        }))))));
+                .then(ArgumentBuilderRequired.<CommandSource, Achievement>argument("achievement", ArgumentTypeAchievement.achievement())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        Player player = requireSender(source);
+                        Achievement achievement = c.getArgument("achievement", Achievement.class);
+
+                        if (player.getStat(achievement) != 0) {
+                            throw PLAYER_ALREADY_HAS_ACHIEVEMENT.create();
+                        }
+
+                        grantAchievements(player, collectWithAncestors(achievement));
+                        source.sendTranslatableMessage("command.commands.achievement.grant.success_single_entity", achievement.getStatName().trim(), player.getDisplayName());
+
+                        return Command.SINGLE_SUCCESS;
+                    }))
+                .then(ArgumentBuilderLiteral.<CommandSource>literal("*")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        Player player = requireSender(source);
+
+                        for (Achievement achievement : Achievements.achievementList) {
+                            grantAchievements(player, collectWithAncestors(achievement));
+                        }
+
+                        source.sendTranslatableMessage("command.commands.achievement.grant.all.success_single_entity", player.getDisplayName());
+
+                        return Command.SINGLE_SUCCESS;
+                    })))
+            .then((ArgumentBuilderLiteral.<CommandSource>literal("revoke"))
+                .then(ArgumentBuilderRequired.<CommandSource, Achievement>argument("achievement", ArgumentTypeAchievement.achievement())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        Player player = requireSender(source);
+                        Achievement achievement = c.getArgument("achievement", Achievement.class);
+
+                        revokeAchievements(player, collectWithDescendants(achievement));
+                        source.sendTranslatableMessage("command.commands.achievement.revoke.success_single_entity", achievement.getStatName().trim(), player.getDisplayName());
+
+                        return Command.SINGLE_SUCCESS;
+                    }))
+                .then(ArgumentBuilderLiteral.<CommandSource>literal("*")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        Player player = requireSender(source);
+
+                        revokeAchievements(player, collectAllAchievementsByDepthDesc());
+                        source.sendTranslatableMessage("command.commands.achievement.revoke.all.success_single_entity", player.getDisplayName());
+
+                        return Command.SINGLE_SUCCESS;
+                    })))));
+    }
+
+    private static @NotNull Player requireSender(CommandSource source) throws CommandSyntaxException {
+        Player player = source.getSender();
+        if (player == null) {
+            throw CommandExceptions.notInWorld().create();
+        }
+        return player;
+    }
+
+    private static void grantAchievements(Player player, List<Achievement> achievements) {
+        for (int i = 0; i < achievements.size(); i++) {
+            Achievement achievement = achievements.get(achievements.size() - 1 - i);
+            player.triggerAchievement(achievement);
+        }
     }
 
-    private static void sendContextualMessage(CommandSource source, List<? extends Entity> entities, Achievement achievement) {
-        if (entities.size() == 1) {
-            source.sendTranslatableMessage("command.commands.achievement.grant.success_single_entity", achievement.getStatName().trim(), ((Mob) entities.get(0)).getDisplayName());
-        } else {
-            source.sendTranslatableMessage("command.commands.achievement.grant.success_multiple_entities", achievement.getStatName(), entities.size());
+    private static void revokeAchievements(Player player, List<Achievement> achievements) {
+        for (Achievement achievement : achievements) {
+            player.revokeAchievement(achievement);
+        }
+    }
+
+    private static List<Achievement> collectWithAncestors(Achievement achievement) {
+        List<Achievement> achievements = new ArrayList<>();
+        achievements.add(achievement);
+
+        while (achievements.get(achievements.size() - 1).parent != null) {
+            achievements.add(achievements.get(achievements.size() - 1).parent);
+        }
+
+        return achievements;
+    }
+
+    private static List<Achievement> collectWithDescendants(Achievement achievement) {
+        List<Achievement> achievements = new ArrayList<>();
+
+        for (Achievement candidate : Achievements.achievementList) {
+            if (isDescendantOf(candidate, achievement)) {
+                achievements.add(candidate);
+            }
+        }
+
+        achievements.sort(Comparator.comparingInt(CommandAchievement::getDepth).reversed());
+        return achievements;
+    }
+
+    private static List<Achievement> collectAllAchievementsByDepthDesc() {
+        List<Achievement> achievements = new ArrayList<>(Achievements.achievementList);
+        achievements.sort(Comparator.comparingInt(CommandAchievement::getDepth).reversed());
+        return achievements;
+    }
+
+    private static boolean isDescendantOf(Achievement achievement, Achievement ancestor) {
+        if (achievement == ancestor) {
+            return true;
+        }
+        Achievement parent = achievement.parent;
+        while (parent != null) {
+            if (parent == ancestor) {
+                return true;
+            }
+            parent = parent.parent;
         }
+        return false;
     }
 
-    private static void sendWildcardContextualMessage(CommandSource source, List<? extends Entity> entities) {
-        if (entities.size() == 1) {
-            source.sendTranslatableMessage("command.commands.achievement.grant.all.success_single_entity", ((Mob) entities.get(0)).getDisplayName());
-        } else {
-            source.sendTranslatableMessage("command.commands.achievement.grant.all.success_multiple_entities", entities.size());
+    private static int getDepth(Achievement achievement) {
+        int depth = 0;
+        Achievement parent = achievement.parent;
+        while (parent != null) {
+            depth++;
+            parent = parent.parent;
         }
+        return depth;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java
index a7e0005fd..7c8d649e5 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.net.packet;
 
 import net.minecraft.core.net.handler.PacketHandler;
-import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 
 import java.io.*;
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketUpdatePlayerState.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketUpdatePlayerState.java
index 596b23723..ea700c1ed 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketUpdatePlayerState.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketUpdatePlayerState.java
@@ -9,6 +9,8 @@ public class PacketUpdatePlayerState extends Packet
     public static final int STATE_SNEAK = 1;
     public static final int STATE_UN_SNEAK = 2;
     public static final int STATE_LEAVE_BED = 3;
+    public static final int STATE_NO_CLIP = 4;
+    public static final int STATE_DO_CLIP = 5;
     public int state;
 
     public PacketUpdatePlayerState()
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/InventorySorter.java b/game/core/src/main/java/net/minecraft/core/player/inventory/InventorySorter.java
index d2b418fa6..6c14a87ce 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/InventorySorter.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/InventorySorter.java
@@ -1,8 +1,11 @@
 package net.minecraft.core.player.inventory;
 
+import it.unimi.dsi.fastutil.ints.IntSet;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
+import java.util.Comparator;
 import java.util.List;
 
 public abstract class InventorySorter {
@@ -11,28 +14,21 @@ public abstract class InventorySorter {
     }
 
     public static void sortInventory(final ItemStack[] inventory, final int startIndex, final int endIndex) {
+        sortInventory(inventory, null, startIndex, endIndex);
+    }
+
+    public static void sortInventory(final ItemStack[] inventory, final @Nullable IntSet lockedSlots, final int startIndex, final int endIndex) {
         final List<ItemStack> items = new ArrayList<>();
 
         for (int i = startIndex; i <= endIndex; i++) {
-            if (inventory[i] == null) {
+            if (inventory[i] == null || (lockedSlots != null && lockedSlots.contains(i))) {
                 continue;
             }
             items.add(inventory[i]);
             inventory[i] = null;
         }
 
-        items.sort((a, b) -> {
-            final int aId = a.itemID;
-            final int bId = b.itemID;
-
-            if (aId == bId) {
-                return 0;
-            }
-            if (aId < bId) {
-                return -1;
-            }
-            return 1;
-        });
+        items.sort(Comparator.comparingInt(a -> a.itemID));
 
         // Merge stacks
         for (int i = 0; i < items.size(); i++) {
@@ -80,8 +76,16 @@ public abstract class InventorySorter {
             return 1;
         });
 
-        for (int i = 0; i < items.size(); i++) {
-            inventory[startIndex + i] = items.get(i);
+        int invIndex = startIndex;
+        for (int i = 0; i < items.size();) {
+            if (lockedSlots != null && lockedSlots.contains(invIndex)) {
+                invIndex++;
+                continue;
+            }
+            inventory[invIndex] = items.get(i);
+
+            invIndex++;
+            i++;
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
index ebfa5e378..df3040bd7 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
@@ -4,6 +4,8 @@ package net.minecraft.core.player.inventory.container;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 
+import it.unimi.dsi.fastutil.ints.IntArraySet;
+import it.unimi.dsi.fastutil.ints.IntSet;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
@@ -422,7 +424,10 @@ public class ContainerInventory
 
     @Override
     public void sort() {
-        InventorySorter.sortInventory(this.mainInventory, HOTBAR_SIZE, MAIN_INVENTORY_SIZE - 1);
+        class Cache {private static final IntSet intSet = new IntArraySet();}
+        Cache.intSet.clear();
+        if (currentSlotLocked()) Cache.intSet.add(this.currentSlot);
+        InventorySorter.sortInventory(this.mainInventory, Cache.intSet, HOTBAR_SIZE, MAIN_INVENTORY_SIZE - 1);
     }
 
     public void transferAllContents(final @NotNull ContainerInventory inventory) {
